<template>
  <div>
    <label> Gameworld Name</label>
    <input type="text" v-model="name">
    <label> Player Amount</label>
    <input type="number" v-model="playerAmount">
    <label> Gameworld Settings</label>
    <label> Map</label>
    <label class="subcat"> Type</label>
    <div class ="inline">
      <label class="subsubcat"> default</label>
      <input type="radio" name="type" value="default" id="default" @click="maptype='default'" checked>
    </div>
    <div class ="inline">
      <label class="subsubcat"> corridor</label>
      <input type="radio" name="type" value='corridor' id="corridor" @click="maptype='corridor'" >
    </div>
    <div class ="inline">
      <label class="subsubcat"> custom</label>
      <input type="radio" name="type" value="custom" id="custom" @click="maptype='custom'">
    </div>
    <div class ="inline">
      <label class="subsubcat"> islands</label>
      <input type="radio" name="type" value='islands' id="island" @click="maptype='islands'" >
    </div>
    <div class ="inline">
      <label class="subsubcat"> maze</label>
      <input type="radio" name="type" value='maze' id="maze" @click="maptype='maze'" >
    </div>
    <label class="subcat"> Size</label>
    <input type="number" v-model="mapsize">
<div>
    <label class="subcat" > Options</label>
    <div class="inline" v-show="maptype==='custom'">
      <label class="subsubcat"> layout (must match map size, consists of X and O)</label>
      <input type="text" v-model="layout">
    </div>
    <div class="inline" v-show="maptype==='corridor'">
      <label class="subsubcat"> width (Numeric > 0, default is 1)</label>
      <input type="number" v-model="width">
    </div>
    <div class="inline" v-show="maptype==='islands'">
      <label class="subsubcat"> size (Numeric between 0 and 1, default is 0.75)</label>
      <input type="number" v-model="islandSize">
    </div>
    <div class="inline" v-show="maptype==='maze'">
      <label class="subsubcat"> clusters (Numeric between 0 and 1, default is 0.02)</label>
      <input type="number" v-model="clusters">
    </div>
    <div class="inline" v-show="maptype==='corridor' || maptype==='islands'">
      <label class="subsubcat"> frequenzy  (Numeric between 0 and 1)</label>
      <input type="number" v-model="corridorFreq">
    </div>
    <label> Rescources</label>
    <div class="inline">
      <label class="subcat"> minAmount</label>
      <input type="number" v-model="resMin">
    </div>
      <div class="inline">
      <label class="subcat"> maxAmount</label>
      <input type="number" v-model="resMax">
    </div>
    <label> areas (overrides default placement entirely, below numeric between 0 and 1)</label>
    <label class="subsubcat"> border</label>
    <div class="resource">
      <label> Coal</label>
      <input type="number" v-model="borderCoal">
      <label > Iron</label>
      <input type="number" v-model="borderIron">
      <label> Gem</label>
      <input type="number" v-model="borderGem">
      <label> Gold</label>
      <input type="number" v-model="borderGold">
      <label> Platin</label>
      <input type="number" v-model="borderPlatin">
    </div>
    <label class="subsubcat"> outer</label>
    <div class="resource">
      <label> Coal</label>
      <input type="number" v-model="outerCoal">
      <label > Iron</label>
      <input type="number" v-model="outerIron">
      <label> Gem</label>
      <input type="number" v-model="outerGem">
      <label> Gold</label>
      <input type="number" v-model="outerGold">
      <label> Platin</label>
      <input type="number" v-model="outerPlatin">
    </div>
    <label class="subsubcat"> middle</label>
    <div class="resource">
      <label> Coal</label>
      <input type="number" v-model="middleCoal">
      <label > Iron</label>
      <input type="number" v-model="middleIron">
      <label> Gem</label>
      <input type="number" v-model="middleGem">
      <label> Gold</label>
      <input type="number" v-model="middleGold">
      <label> Platin</label>
      <input type="number" v-model="middlePlatin">
    </div>
    <label class="subsubcat"> inner</label>
    <div class="resource">
      <label> Coal</label>
      <input type="number" v-model="innerCoal">
      <label > Iron</label>
      <input type="number" v-model="innerIron">
      <label> Gem</label>
      <input type="number" v-model="innerGem">
      <label> Gold</label>
      <input type="number" v-model="innerGold">
      <label> Platin</label>
      <input type="number" v-model="innerPlatin">
    </div>
  </div>
</div>
  <button @click="submit()" id="submit_button">Submit</button>
</template>

<script lang="ts">
import  rescourceInput  from '@/components/rescource-field.vue';
import rescources from '@/components/rescources.json';
import { store } from 'vuex/types/index.js';
    export default{
        name: 'createFormular',
        data: () => ({
          rescources,
          maptype: "default",
          playerAmount: 1,
          layout: null,
          width: null,
          islandSize: null,
          clusters: null,
          corridorFreq: null,
          resMin: null,
          resMax: null,
          mapsize: 5,
          name: "CustomGameworld",
          borderCoal: null,
          borderIron: null,
          borderGem: null,
          borderGold: null,
          borderPlatin: null,
          outerCoal: null,
          outerIron: null,
          outerGem: null,
          outerGold: null,
          outerPlatin: null,
          middleCoal: null,
          middleIron: null,
          middleGem: null,
          middleGold: null,
          middlePlatin: null,
          innerCoal: null,
          innerIron: null,
          innerGem: null,
          innerGold: null,
          innerPlatin: null,
        }),
        methods:{
          async submit(){
            document.getElementById("submit_button").disabled = true;
            try{
              let requestBody = this.buildRequestBody();
              const response = await this.$store.dispatch('createGameworld', requestBody);

              if(response == null)
                throw new Error("world could not get created!");
              let gameworld = await this.$store.dispatch('getThisGameworld', response);
              gameworld = this.$store.state.gameData;

              gameworld.status = "INACTIVE";
              gameworld.name = this.name;
              await this.$store.commit('setGameData', gameworld);
              await this.$store.dispatch('saveThisGameworld');
              document.getElementById("submit_button").disabled = false;
              this.$emit('formsubmittedEvent');
            }catch(error){
              document.getElementById("submit_button").disabled = false;
              console.error(error);
            }
            
          },
          buildRequestBody(): any{
            interface resourcesDistribuion  {
              coal?: string | null;
              iron?: string | null;
              gem?: string | null;
              gold?: string | null;
              platin?: string | null;
            }
            interface requestBodyInterface {
              playerAmount: 1 | number;
              gameworldSettings?: {
                seed: 0 | number,
                map? : {
                  type: string | 'default',
                  size?: number | null,
                  options?: {
                    layout?: string | null,
                    width?: string | null,
                    size?: number | null,
                    clusters?: number | null,
                    frequency?: number | null
                  },
                },  
                resources?: {
                  minAmount?: number | null,
                  maxAmount?: number | null,
                  areas?: {
                    border?: {
                      coal?: number | null,
                      iron?: number | null,
                      gem?: number | null,
                      gold?: number | null,
                      platin?: number | null,
                    }
                    outer?: {
                      coal?: number | null,
                      iron?: number | null,
                      gem?: number | null,
                      gold?: number | null,
                      platin?: number | null,
                    }
                    mid?: {
                      coal?: number | null,
                      iron?: number | null,
                      gem?: number | null,
                      gold?: number | null,
                      platin?: number | null,
                    },
                    inner?: {
                      coal?: number | null,
                      iron?: number | null,
                      gem?: number | null,
                      gold?: number | null,
                      platin?: number | null,
                    }
                  }
                }
              }
            }
            if(this.playerAmount!=null && this.playerAmount<1)
              this.playerAmount=1;
            if(this.mapsize!=null && this.mapsize<5)
              this.mapsize=5;

            let requestBody: requestBodyInterface = {
              playerAmount: this.playerAmount ?? 1,
              gameworldSettings: {
                seed: 0,
                map : {
                  type: this.maptype,
                  size: this.mapsize ?? 5,
                  options: {
                    layout: this.layout ?? null,
                    width: this.width ?? null,
                    size:this.islandSize ?? null,
                    clusters: this.clusters ?? null,
                    frequency: this.corridorFreq ?? null
                  },
                },  
                resources: {
                  minAmount: this.resMin ?? null,
                  maxAmount: this.resMax ?? null,
                  areas: {
                    border : {
                      coal: this.borderCoal ?? null,
                      iron: this.borderIron ?? null,
                      gem: this.borderGem ?? null,
                      gold: this.borderGold ?? null,
                      platin: this.borderPlatin ?? null
                    },
                    outer: {
                      coal: this.outerCoal ?? null,
                      iron: this.outerIron ?? null,
                      gem: this.outerGem ?? null,
                      gold: this.outerGold ?? null,
                      platin: this.outerPlatin ?? null
                    },
                    mid: {
                      coal: this.middleCoal ?? null,
                      iron: this.middleIron ?? null,
                      gem: this.middleGem ?? null,
                      gold: this.middleGold ?? null,
                      platin: this.middlePlatin ?? null
                    },
                    inner: {
                      coal: this.innerCoal ?? null,
                      iron: this.innerIron ?? null,
                      gem: this.innerGem ?? null,
                      gold: this.innerGold ?? null,
                      platin: this.innerPlatin ?? null
                    }
                  }
                }
              }
            };
            
            this.deleteNullFromObj(requestBody.gameworldSettings?.resources?.areas?.border);
            this.deleteNullFromObj(requestBody.gameworldSettings?.resources?.areas?.outer);
            this.deleteNullFromObj(requestBody.gameworldSettings?.resources?.areas?.mid);
            this.deleteNullFromObj(requestBody.gameworldSettings?.resources?.areas?.inner);

            if(this.isEmpty(requestBody.gameworldSettings?.resources?.areas?.border))
              delete requestBody.gameworldSettings?.resources?.areas?.border
            if(this.isEmpty(requestBody.gameworldSettings?.resources?.areas?.outer))
              delete requestBody.gameworldSettings?.resources?.areas?.outer
            if(this.isEmpty(requestBody.gameworldSettings?.resources?.areas?.mid))
              delete requestBody.gameworldSettings?.resources?.areas?.mid
            if(this.isEmpty(requestBody.gameworldSettings?.resources?.areas?.inner))
              delete requestBody.gameworldSettings?.resources?.areas?.inner

            if(this.resMin == null)
              delete requestBody.gameworldSettings?.resources?.minAmount
            if(this.resMax == null)
              delete requestBody.gameworldSettings?.resources?.maxAmount

            if(this.isEmpty(requestBody.gameworldSettings?.resources?.areas))
              delete requestBody.gameworldSettings?.resources?.areas;
            if(this.isEmpty(requestBody.gameworldSettings?.resources))
              delete requestBody.gameworldSettings?.resources;

            if(this.mapsize == null)
              delete requestBody.gameworldSettings?.map?.size;

            if(this.maptype == "default"){
              delete requestBody.gameworldSettings?.map?.options;
              if(this.mapsize == null){
                delete requestBody.gameworldSettings;
              }
            }

            if(this.isEmpty(requestBody.gameworldSettings?.map?.options)){
                delete requestBody.gameworldSettings?.map?.options;
              }
              if(this.width == null)
                delete requestBody.gameworldSettings?.map?.options?.width;
              if(this.clusters == null)
                delete requestBody.gameworldSettings?.map?.options?.clusters;
              if(this.layout == null)
                delete requestBody.gameworldSettings?.map?.options?.layout;
              if(this.islandSize == null)
                delete requestBody.gameworldSettings?.map?.options?.size;
              if(this.corridorFreq == null)
                delete requestBody.gameworldSettings?.map?.options?.frequency;
            return requestBody;
          },
          deleteNullFromObj(obj: {[key: string]: number | string | null | undefined} = {}){
              for(let key in obj){
                if(obj[key] === undefined || obj[key] === null)
                  delete obj[key as keyof typeof obj];
              }
              return obj;
          },
          isEmpty(obj: {[key: string]: number | string | null | undefined}): boolean{
            for(let key in obj){
              if(obj[key]!== null || obj[key]!== undefined){
                return false;
              }
            }
            return true;
          }

        }
        
      
        
    }
</script>

<style>
label {
  display: block;
  margin-bottom: 0.5rem;
  text-transform: uppercase;
  color: rgb(61, 59, 59);
  font-weight: 700;
  font-size: 0.8rem;
}
input {
  display: inline-block;
  width: 90%;
  padding: 0.4rem;
  margin: 0.5rem;
}
.subcat{
  display: block;
  margin-left: 0.4rem;
}
.subsubcat{
  margin-left: 0.8rem;
}

.resource{
  display: flex;
  justify-content: flex-end;
}

.inline{
  display:inline-block;
}
.invalid{
  color: red;
}
.valid{
  color:green;
}
</style>
